#if defined(__CPU_ARC__) /* Do not compile this on AVR based boards */
#ifndef CURIE_BLE_SERIAL_H
#define CURIE_BLE_SERIAL_H

#include "Stream.h"
#include <CurieBLE.h>

#define SERVICE_UUID "19B10010-E8F2-537E-4F6C-D104768A1214"
#define OUTPUT_UUID "a0010011-E8F2-537E-4F6C-D104768A1214"
#define INPUT_UUID "b0010011-E8F2-537E-4F6C-D104768A1214"

class CurieBLESerial : public Stream
{
public:
  CurieBLESerial();
  virtual int available(void);
  virtual int peek(void);
  virtual int read(void);
  virtual void flush(void);
  virtual size_t write(uint8_t);
  virtual size_t write(const char *str);
  virtual size_t write(const uint8_t *buffer, size_t size);
  void begin(void);
  BLECharacteristic *getInputCharacteristic();
  BLECharacteristic *getOutputCharacteristic();
  BLEPeripheral *getPeripheral();
  void setBuffer(char *buffer);
private:
  BLEPeripheral *_peripheral;
  BLEService *_dataTransferService;
  BLECharacteristic *_outputCharacteristic;
  BLECharacteristic *_inputCharacteristic;
  char _buffer[20];
  int _buffer_s = 0;
  int _buffer_e = 0;
};
#endif
#endif
